#!/usr/bin/python
# encoding: utf-8

from ftplib import FTP
from ftplib import FTP_TLS
import sys
import os.path
import hashlib
import os
import ssl
import argparse
import getpass


class MyFTP(FTP):
    '''
    connect to FTP Server
    '''
    def __init__(self):
        print('make a object')


    def ConnectFTP(self, remote_ip="", remote_port=21, login_name="", login_password=""):
        # ftp = FTP()
        ftp = FTP_TLS()
        ftp.ssl_version = ssl.PROTOCOL_TLSv1_2

        try:
            ftp.connect(remote_ip, remote_port, 600)
            print('Connect Success')
        except Exception as e:
            print(sys.stderr, "Coonnect Failed - %s" %e)
            return (0, 'Connect Failed')
        else:
            try:
                ftp.login(login_name, login_password)
                print('login Success')
            except Exception as e:
                print(sys.stderr, "Login Failed - %s" %e)
                return (0, 'Login Faild')
            else:
                print('retrun 1')
                return (1, ftp)


    def Download(self, remoteHost="", remotePort="", login_name="", login_password="", remotePath="", localPath=""):
        # connect to the FTP Server and check the return
        res = self.ConnectFTP(remote_ip=remoteHost, remote_port=remotePort, login_name=login_name, login_password=login_password)
        if (res[0] != 1):
            print(sys.stderr, res[1])
            sys.exit(1)


        # change the remote directory and get the remote file size
        ftp = res[1]
        ftp.set_pasv(1)
        dires = self.splitpath(remotePath)
        # if dires[0]:
        #     # change remote work dir
        #     ftp.cwd(dires[0])
        remotefile = dires[1]
        print(dires[0],'---',dires[1])
        fsize = ftp.size(remotefile)
        if fsize == 0:
            return

        # check if local file exists and get the local file size
        lsize = 0
        if os.path.exists(localPath):
            lsize = os.stat(localPath).st_size

        if lsize >= fsize:
            print('local file is bigger or equal remote file')
            return

        blocksize = 1024*1024
        cmpsize = lsize
        ftp.voidcmd('TYPE I')
        conn = ftp.transfercmd('RETR ' + remotefile, lsize)
        lwrite = open(localPath, 'ab')
        while True:
            data = conn.recv(blocksize)
            if not data:
                break
            lwrite.write(data)
            cmpsize += len(data)
            print('\b'*30,'download process:%.2f%%'%(float(cmpsize)/fsize*100))
        lwrite.close()
        ftp.voidcmd('NOOP')
        ftp.voidresp()
        conn.close()


    def upload(self, remoteHost="", remotePort="", login_name="", login_password="", remotePath="", localPath="", callback=None):
        if not os.path.exists(localPath):
            print("local file doesn't exists")
            return
        self.set_debuglevel(2)
        res = self.ConnectFTP(remote_ip=remoteHost, remote_port=remotePort, login_name=login_name, login_password=login_password)

        if res[0] != 1:
            print(res[1])
            sys.exit()
        ftp = res[1]
        remote = self.splitpath(remotePath)
        ftp.cwd(remote[0])
        rsize = 0
        try:
            rsize = ftp.size(remote[1])
        except Exception as e:
            pass

        if (rsize==None):
            rsize = 0
        lsize = os.stat(localPath).st_size
        print('rsize : %d, lsize : %d' % (rsize, lsize))
        if (rsize == lsize):
            print('remote filesize is equal with local')
            return

        if (rsize < lsize):
            localfile = open(localPath, 'rb')
            localfile.seek(rsize)
            ftp.voidcmd('TYPE I')
            datesock = ''
            esize = ''
            try:
                print(remote[1])
                datasock, esize = ftp.ntransfercmd("STOR "+remote[1],rsize)
            except Exception as e:
                print(sys.stderr, '----------ftp.ntransfercmd-------- : %s' % e)
                return
            cmpsize = rsize

            while True:
                buf = localfile.read(1024*1024)
                if not len(buf):
                    print('no data')
                    break
                datasock.sendall(buf)
                if callback:
                    callback(buf)
                cmpsize  += len(buf)
                print('\b'*30,'uploading %.2f%%'%(float(cmpsize)/lsize*100))

                if cmpsize == lsize:
                    print('file size equal')
                    break
            datasock.close()
            print('close data handle')
            localfile.close()
            ftp.voidcmd('NOOP')
            ftp.voidresp()
            ftp.quit()


    def splitpath(self, remotepath):
        position = remotepath.rfind('/')
        return (remotepath[:position+1], remotepath[position+1:])


    def md5_calc(self, file):
        md5_value = hashlib.md5()
        with open(file, 'rb') as file_b:
            while True:
                data_flow = file_b.read(8096)  # 每次读入8089kb进入内存
                if not data_flow:  # 读取完后返回空值，False
                    break
                md5_value.update(data_flow)
        file_b.close()
        return md5_value.hexdigest()


    def get_filesize(self, filename):
        fsize = os.path.getsize(filename)
        return fsize


def main():
    parser = argparse.ArgumentParser(description="FTP Upload and Download Utility")
    parser.add_argument("--method", choices=["upload", "download"], required=True, help="Specify the method (upload or download)")
    parser.add_argument("--file", required=True, help="Specify the file name for upload or download")

    args = parser.parse_args()

    login_name = input("Enter FTP username: ")
    login_password = getpass.getpass("Enter FTP password: ")

    ftpobj = MyFTP()
    if args.method == "upload":
        ftpobj.upload(
            remoteHost='93.127.132.250',
            remotePort=10021,
            login_name=login_name,
            login_password=login_password,
            remotePath="/ftp-download/" + args.file,
            localPath=args.file
        )
    elif args.method == "download":
        ftpobj.Download(
            remoteHost='93.127.132.250',
            remotePort=10021,
            login_name=login_name,
            login_password=login_password,
            remotePath="/ftp-download/" + args.file,
            localPath=args.file
        )

if __name__ == "__main__":
    main()
